//#line 2 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the raspicam_node package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __raspicam_node__CAMERACONFIG_H__
#define __raspicam_node__CAMERACONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace raspicam_node
{
  class CameraConfigStatics;

  class CameraConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      virtual ~AbstractParamDescription() = default;

      virtual void clamp(CameraConfig &config, const CameraConfig &max, const CameraConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const CameraConfig &config1, const CameraConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, CameraConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const CameraConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraConfig &config) const = 0;
      virtual void getValue(const CameraConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T CameraConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T CameraConfig::* field;

      virtual void clamp(CameraConfig &config, const CameraConfig &max, const CameraConfig &min) const override
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const CameraConfig &config1, const CameraConfig &config2) const override
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, CameraConfig &config) const override
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const CameraConfig &config) const override
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraConfig &config) const override
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraConfig &config) const override
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const CameraConfig &config, boost::any &val) const override
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      virtual ~AbstractGroupDescription() = default;

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, CameraConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, CameraConfig &top) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const override
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T PT::* field;
      std::vector<CameraConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(CameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("contrast"==(*_i)->name){contrast = boost::any_cast<int>(val);}
        if("sharpness"==(*_i)->name){sharpness = boost::any_cast<int>(val);}
        if("brightness"==(*_i)->name){brightness = boost::any_cast<int>(val);}
        if("saturation"==(*_i)->name){saturation = boost::any_cast<int>(val);}
        if("ISO"==(*_i)->name){ISO = boost::any_cast<int>(val);}
        if("exposure_compensation"==(*_i)->name){exposure_compensation = boost::any_cast<int>(val);}
        if("video_stabilisation"==(*_i)->name){video_stabilisation = boost::any_cast<bool>(val);}
        if("vFlip"==(*_i)->name){vFlip = boost::any_cast<bool>(val);}
        if("hFlip"==(*_i)->name){hFlip = boost::any_cast<bool>(val);}
        if("shutter_speed"==(*_i)->name){shutter_speed = boost::any_cast<int>(val);}
        if("zoom"==(*_i)->name){zoom = boost::any_cast<double>(val);}
        if("exposure_mode"==(*_i)->name){exposure_mode = boost::any_cast<std::string>(val);}
        if("awb_mode"==(*_i)->name){awb_mode = boost::any_cast<std::string>(val);}
      }
    }

    int contrast;
int sharpness;
int brightness;
int saturation;
int ISO;
int exposure_compensation;
bool video_stabilisation;
bool vFlip;
bool hFlip;
int shutter_speed;
double zoom;
std::string exposure_mode;
std::string awb_mode;

    bool state;
    std::string name;

    
}groups;



//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int contrast;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int sharpness;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int brightness;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int saturation;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int ISO;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_compensation;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool video_stabilisation;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool vFlip;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool hFlip;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int shutter_speed;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double zoom;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string exposure_mode;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string awb_mode;
//#line 231 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("CameraConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const CameraConfig &__max__ = __getMax__();
      const CameraConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const CameraConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const CameraConfig &__getDefault__();
    static const CameraConfig &__getMax__();
    static const CameraConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const CameraConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void CameraConfig::ParamDescription<std::string>::clamp(CameraConfig &config, const CameraConfig &max, const CameraConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class CameraConfigStatics
  {
    friend class CameraConfig;

    CameraConfigStatics()
    {
CameraConfig::GroupDescription<CameraConfig::DEFAULT, CameraConfig> Default("Default", "", 0, 0, true, &CameraConfig::groups);
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.contrast = -100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.contrast = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.contrast = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("contrast", "int", 0, "Contrast", "", &CameraConfig::contrast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("contrast", "int", 0, "Contrast", "", &CameraConfig::contrast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.sharpness = -100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.sharpness = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.sharpness = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("sharpness", "int", 0, "Sharpness", "", &CameraConfig::sharpness)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("sharpness", "int", 0, "Sharpness", "", &CameraConfig::sharpness)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.brightness = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.brightness = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.brightness = 50;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("brightness", "int", 0, "Brightness", "", &CameraConfig::brightness)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("brightness", "int", 0, "Brightness", "", &CameraConfig::brightness)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.saturation = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.saturation = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.saturation = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("saturation", "int", 0, "Saturation", "", &CameraConfig::saturation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("saturation", "int", 0, "Saturation", "", &CameraConfig::saturation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ISO = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ISO = 1600;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ISO = 400;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("ISO", "int", 0, "ISO", "", &CameraConfig::ISO)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("ISO", "int", 0, "ISO", "", &CameraConfig::ISO)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_compensation = -10;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_compensation = 10;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_compensation = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("exposure_compensation", "int", 0, "Exposure Compensation", "", &CameraConfig::exposure_compensation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("exposure_compensation", "int", 0, "Exposure Compensation", "", &CameraConfig::exposure_compensation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.video_stabilisation = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.video_stabilisation = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.video_stabilisation = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("video_stabilisation", "bool", 0, "Video Stabilisation", "", &CameraConfig::video_stabilisation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("video_stabilisation", "bool", 0, "Video Stabilisation", "", &CameraConfig::video_stabilisation)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.vFlip = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.vFlip = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.vFlip = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("vFlip", "bool", 0, "vFlip", "", &CameraConfig::vFlip)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("vFlip", "bool", 0, "vFlip", "", &CameraConfig::vFlip)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.hFlip = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.hFlip = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.hFlip = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("hFlip", "bool", 0, "hFlip", "", &CameraConfig::hFlip)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<bool>("hFlip", "bool", 0, "hFlip", "", &CameraConfig::hFlip)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.shutter_speed = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.shutter_speed = 100000;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.shutter_speed = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("shutter_speed", "int", 0, "Shutter Speed (us)", "", &CameraConfig::shutter_speed)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<int>("shutter_speed", "int", 0, "Shutter Speed (us)", "", &CameraConfig::shutter_speed)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.zoom = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.zoom = 4.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.zoom = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<double>("zoom", "double", 0, "Digital zoom", "", &CameraConfig::zoom)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<double>("zoom", "double", 0, "Digital zoom", "", &CameraConfig::zoom)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_mode = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_mode = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_mode = "auto";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<std::string>("exposure_mode", "str", 0, "Exposure mode", "{'enum': [{'name': 'off', 'type': 'str', 'value': 'off', 'srcline': 21, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'auto', 'type': 'str', 'value': 'auto', 'srcline': 22, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'night', 'type': 'str', 'value': 'night', 'srcline': 23, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'nightpreview', 'type': 'str', 'value': 'nightpreview', 'srcline': 24, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'backlight', 'type': 'str', 'value': 'backlight', 'srcline': 25, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'spotlight', 'type': 'str', 'value': 'spotlight', 'srcline': 26, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'sports', 'type': 'str', 'value': 'sports', 'srcline': 27, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'snow', 'type': 'str', 'value': 'snow', 'srcline': 28, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'beach', 'type': 'str', 'value': 'beach', 'srcline': 29, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'verylong', 'type': 'str', 'value': 'verylong', 'srcline': 30, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'fixedfps', 'type': 'str', 'value': 'fixedfps', 'srcline': 31, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'antishake', 'type': 'str', 'value': 'antishake', 'srcline': 32, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'fireworks', 'type': 'str', 'value': 'fireworks', 'srcline': 33, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Exposure modes'}", &CameraConfig::exposure_mode)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<std::string>("exposure_mode", "str", 0, "Exposure mode", "{'enum': [{'name': 'off', 'type': 'str', 'value': 'off', 'srcline': 21, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'auto', 'type': 'str', 'value': 'auto', 'srcline': 22, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'night', 'type': 'str', 'value': 'night', 'srcline': 23, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'nightpreview', 'type': 'str', 'value': 'nightpreview', 'srcline': 24, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'backlight', 'type': 'str', 'value': 'backlight', 'srcline': 25, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'spotlight', 'type': 'str', 'value': 'spotlight', 'srcline': 26, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'sports', 'type': 'str', 'value': 'sports', 'srcline': 27, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'snow', 'type': 'str', 'value': 'snow', 'srcline': 28, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'beach', 'type': 'str', 'value': 'beach', 'srcline': 29, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'verylong', 'type': 'str', 'value': 'verylong', 'srcline': 30, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'fixedfps', 'type': 'str', 'value': 'fixedfps', 'srcline': 31, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'antishake', 'type': 'str', 'value': 'antishake', 'srcline': 32, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'fireworks', 'type': 'str', 'value': 'fireworks', 'srcline': 33, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Exposure modes'}", &CameraConfig::exposure_mode)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.awb_mode = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.awb_mode = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.awb_mode = "auto";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<std::string>("awb_mode", "str", 0, "AWB mode", "{'enum': [{'name': 'awb_off', 'type': 'str', 'value': 'off', 'srcline': 37, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_auto', 'type': 'str', 'value': 'auto', 'srcline': 38, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_sun', 'type': 'str', 'value': 'sun', 'srcline': 39, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_cloud', 'type': 'str', 'value': 'cloud', 'srcline': 40, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_shade', 'type': 'str', 'value': 'shade', 'srcline': 41, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_tungsten', 'type': 'str', 'value': 'tungsten', 'srcline': 42, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_fluorescent', 'type': 'str', 'value': 'fluorescent', 'srcline': 43, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_incandescent', 'type': 'str', 'value': 'incandescent', 'srcline': 44, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_flash', 'type': 'str', 'value': 'flash', 'srcline': 45, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_horizon', 'type': 'str', 'value': 'horizon', 'srcline': 46, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'AWB modes'}", &CameraConfig::awb_mode)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(CameraConfig::AbstractParamDescriptionConstPtr(new CameraConfig::ParamDescription<std::string>("awb_mode", "str", 0, "AWB mode", "{'enum': [{'name': 'awb_off', 'type': 'str', 'value': 'off', 'srcline': 37, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_auto', 'type': 'str', 'value': 'auto', 'srcline': 38, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_sun', 'type': 'str', 'value': 'sun', 'srcline': 39, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_cloud', 'type': 'str', 'value': 'cloud', 'srcline': 40, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_shade', 'type': 'str', 'value': 'shade', 'srcline': 41, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_tungsten', 'type': 'str', 'value': 'tungsten', 'srcline': 42, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_fluorescent', 'type': 'str', 'value': 'fluorescent', 'srcline': 43, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_incandescent', 'type': 'str', 'value': 'incandescent', 'srcline': 44, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_flash', 'type': 'str', 'value': 'flash', 'srcline': 45, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'awb_horizon', 'type': 'str', 'value': 'horizon', 'srcline': 46, 'srcfile': '/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'AWB modes'}", &CameraConfig::awb_mode)));
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(CameraConfig::AbstractGroupDescriptionConstPtr(new CameraConfig::GroupDescription<CameraConfig::DEFAULT, CameraConfig>(Default)));
//#line 369 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<CameraConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<CameraConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<CameraConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    CameraConfig __max__;
    CameraConfig __min__;
    CameraConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const CameraConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static CameraConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &CameraConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const CameraConfig &CameraConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const CameraConfig &CameraConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const CameraConfig &CameraConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<CameraConfig::AbstractParamDescriptionConstPtr> &CameraConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<CameraConfig::AbstractGroupDescriptionConstPtr> &CameraConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const CameraConfigStatics *CameraConfig::__get_statics__()
  {
    const static CameraConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = CameraConfigStatics::get_instance();

    return statics;
  }

//#line 21 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_off = "off";
//#line 22 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_auto = "auto";
//#line 23 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_night = "night";
//#line 24 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_nightpreview = "nightpreview";
//#line 25 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_backlight = "backlight";
//#line 26 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_spotlight = "spotlight";
//#line 27 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_sports = "sports";
//#line 28 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_snow = "snow";
//#line 29 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_beach = "beach";
//#line 30 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_verylong = "verylong";
//#line 31 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_fixedfps = "fixedfps";
//#line 32 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_antishake = "antishake";
//#line 33 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_fireworks = "fireworks";
//#line 37 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_off = "off";
//#line 38 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_auto = "auto";
//#line 39 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_sun = "sun";
//#line 40 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_cloud = "cloud";
//#line 41 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_shade = "shade";
//#line 42 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_tungsten = "tungsten";
//#line 43 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_fluorescent = "fluorescent";
//#line 44 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_incandescent = "incandescent";
//#line 45 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_flash = "flash";
//#line 46 "/build/ros-noetic-raspicam-node-0.5.0/cfg/Camera.cfg"
      const char * const Camera_awb_horizon = "horizon";
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __CAMERARECONFIGURATOR_H__
